; GUI #
include win64a.inc
includelib gdiplus.lib
include gdiplus.inc
ID_LINES	equ	0
ID_RECTANGLE	equ	1
ID_ELLIPSES	equ	2
ID_ERASE	equ	3
ID_TEXT		equ	4
ID_HELP		equ	5
ID_EXIT		equ	6
ID_SHOW_HIDE	equ	7
ID_SHOW         equ	7
ID_HIDE         equ	7+32
ID_ARC		equ	8
ID_BEZIER	equ	9
ID_PIE          equ	10
ID_POLYGON      equ	11
ID_POLYLINE     equ	12
ID_TRIANGLE     equ	13
ID_CLOSEDCURVE  equ	14
ID_CIRCLE	equ	15
IDM_MENU	equ	37
IDR_MAINACCEL	equ	105
IDC_ICON1	equ	500
Num_buttons	equ	7
SmoothingModeAntiAlias8x8	equ 5
StringAlignmentCenter	equ 1
FontStyleBold	equ	1
ColorsBlue      equ	0FF0000FFh
ColorsGreen     equ	0FF00FF00h
ColorsRed       equ	0FFFF0000h
ColorsYellow    equ	0FFFFFF00h
ColorsBlack     equ	0FF000000h

WrapModeTile equ 0
WrapModeTileFlipX equ 1
WrapModeTileFlipY equ 2
WrapModeTileFlipXY equ 3
WrapModeClamp equ 4

UnitWorld equ 0
UnitDisplay equ 1
UnitPixel equ 2
UnitPoint equ 3
UnitInch equ 4
UnitDocument equ 5
UnitMillimeter equ 6

PenAlignmentCenter equ 0
PenAlignmentInset equ 1

BrushTypeSolidColor equ 0
BrushTypeHatchFill equ 1
BrushTypeTextureFill equ 2
BrushTypePathGradient equ 3
BrushTypeLinearGradient equ 4

LineCapRoundAnchor equ	12h
LineCapArrowAnchor equ	14h
LineJoinBevel	equ	1

PointF STRUCT
	x REAL4 ?
	y REAL4 ?
PointF ENDS

RectF STRUCT
	Left REAL4 ?
	Top REAL4 ?
	Right REAL4 ?
	Bottom REAL4 ?
RectF ENDS

SizeF STRUCT
	sx REAL4 ?
	sy REAL4 ?
SizeF ENDS
;-----------------------------------------
.code
WinMain proc 
local msg:MSG
local hwnd:HWND

	mov ecx,offset gdiplusToken
        mov edx,offset gdiplusStartupInput
        invoke GdiplusStartup,,,0

	xor ebx,ebx
	mov esi,IMAGE_BASE
	mov ecx,offset FileName
	invoke LoadCursorFromFile
	mov edi,offset ClassName
	push rax	;hIconSm
	push rdi	;lpszClassName
	push IDM_MENU	;lpszMenuName
	push COLOR_WINDOW+1;hbrBackground
	push 10003h	;hCursor
	push rax        ;hIcon
	push rsi	;hInstance
	push rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc      ;lpfnWndProc
	push sizeof WNDCLASSEX;cbSize & style
	invoke RegisterClassEx,esp	;addr WNDCLASSEX	
	push rbx
	push rsi	;rsi=400000h
	shl esi,9	;rsi=CW_USEDEFAULT
	push rbx
	push rbx
	push rsi
	push rsi
	push rsi
	push rsi
	sub esp,20h
    	invoke CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_VISIBLE
        mov hwnd,rax
	invoke GetMenu,eax
	mov hMenu,rax
	invoke LoadAccelerators,IMAGE_BASE,IDR_MAINACCEL
	mov ACC,rax
	mov qword ptr [rbp-0F8h],LR_LOADFROMFILE
	mov [rbp-100h],rbx
	mov edx,offset aMybp1
	invoke LoadImage,IMAGE_BASE,,0,0
 ;   -      TBBUTTON
	mov edx,sizeof TBBUTTON
	mov bl,Num_buttons-1
	lea rcx,[tbb+sizeof TBBUTTON*(Num_buttons-1)]
@@:	mov [rcx+TBBUTTON.iBitmap],ebx;   (   0)
	mov [rcx+TBBUTTON.idCommand],ebx;  ID_1 ID_2 ID_3
	mov [rcx+TBBUTTON.fsState],TBSTATE_ENABLED;; 
; TBSTATE_ENABLED      
	or ebx,ebx;   ebx      2  0
	jz @f
	sub ecx,edx;    TBBUTTON
	dec ebx
	jmp @b
@@:	mov [rbp-0C0h],rdx;size TBBUTTON  ;size of structure TBBUTTON
	mov edx,18
	mov [rbp-0C8h],rdx;  
	mov [rbp-0D0h],rdx;                               
	mov [rbp-0D8h],rdx;  
	mov [rbp-0E0h],rdx;              
	mov qword ptr [rbp-0E8h],Num_buttons;             
	mov [rbp-0F0h],rcx;    TBBUTTON
	mov [rbp-0F8h],rax;                                               
	mov [rbp-100h],rbx;0
	invoke CreateToolbarEx,hwnd,WS_CHILD or \
        WS_BORDER or WS_VISIBLE or TBSTYLE_TOOLTIPS,-1,Num_buttons
;   ,
;         -1
;Num_buttons -      bmp
;WS_BORDER or WS_VISIBLE or TBSTYLE_TOOLTIPS -   
;hwnd -   
	mov tbwnd,rax
    	lea edi,msg
@@:     invoke GetMessage,edi,0,0,0
        invoke TranslateAccelerator,hwnd,ACC,edi
	or eax,eax
	jne @b
	invoke TranslateMessage,edi;  
	invoke DispatchMessage,edi
	jmp @b
WinMain endp
WndProc proc hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local ps:PAINTSTRUCT
local hdc:HDC
local lpttt:QWORD
local hBrushX:QWORD
local hBrushG:QWORD
local hFont:QWORD
local hFontA:QWORD
local lb:LOGBRUSH

	mov hWnd,rcx
	mov wParam,r8
	mov  lParam,r9

	cmp  edx,WM_DESTROY
	je   wmDESTROY
	cmp  edx,WM_CREATE
	je   wmCREATE
	cmp  edx,WM_PAINT
	je   wmPAINT
	cmp  edx,WM_SIZE
	je   wmSIZE
	cmp  edx,WM_COMMAND
	je   wmCOMMAND
        cmp  edx,WM_NOTIFY
	je   wmNOTIFY
	leave
	jmp NtdllDefWindowProc_
wmDESTROY:invoke GdipDeleteGraphics,graphics
	invoke RtlExitUserProcess,NULL

wmCREATE:invoke GetDC
	mov hdc,rax

        invoke GetSystemMetrics, SM_CXSCREEN
	mov maxX,rax
	invoke GetSystemMetrics, SM_CYSCREEN
	mov maxY,rax
	invoke CreateCompatibleDC,hdc
	mov hdcMem,rax
	invoke CreateCompatibleBitmap,hdc,maxX,maxY
	mov hbmp,rax
	invoke ReleaseDC,hWnd,hdc

	invoke SelectObject,hdcMem,hbmp
        mov hbmpDef,rax
        mov edx,offset graphics
        invoke GdipCreateFromHDC, hdcMem

        invoke PatBlt,hdcMem,0,0,maxX,maxY,PATCOPY
        jmp wmBYE
wmRectangles:
	mov ecx,offset points
	invoke GdipCreatePathGradientI,,4,0,&hBrush
	invoke GdipSetPathGradientCenterColor,hBrush,ColorsBlue

	invoke GdipFillEllipseI,graphics,hBrush,400,110,90,90
	invoke GdipFillEllipseI,graphics,hBrush,450,110,90,90
	invoke GdipFillEllipseI,graphics,hBrush,500,110,90,90
	
	invoke GdipFillRectangleI,graphics,hBrush,300,300,200,200
	invoke GdipDeleteBrush,hBrush

        mov edx,offset p2
	mov ecx,offset p1
	mov r8d,0FFFF0000h
	mov r9d,900000FFh
	and qword ptr [rsp+20h],0
	movr qword ptr [rsp+28h],hBrush
	invoke GdipCreateLineBrushI
        mov qword ptr [rsp+20h],300
        mov qword ptr [rsp+28h],300
	invoke GdipFillRectangleI,graphics,hBrush,0,0
	invoke GdipDeleteBrush,hBrush
	jmp wmSIZE
wmLines:
; 
	lea r9d,nativePen
	movd xmm1,EpaisseurStylo
	invoke GdipCreatePen1,ColorsGreen,,0
	invoke GdipDrawLineI,graphics,nativePen,40,40, 200, 100 ;x1,y1,x2,y2	
;"" 
	mov r9d,offset blackPen
	movd xmm1,wi1
	invoke GdipCreatePen1,ColorsBlack,,UnitWorld
	mov r9d,offset greenPen
	movd xmm1,wi2
	invoke GdipCreatePen1,ColorsGreen,,UnitWorld
	invoke GdipSetPenMode,greenPen,PenAlignmentCenter
	invoke GdipDrawLineI,graphics,greenPen,230,300,300,250
	invoke GdipDrawLineI,graphics,blackPen,230,300,300,250
;     
	invoke GdipDrawRectangleI,graphics,greenPen,210,220,100,100
	invoke GdipDrawRectangleI,graphics,blackPen,210,220,100,100
;     
	invoke GdipSetPenMode,greenPen,PenAlignmentInset
	invoke GdipDrawRectangleI,graphics,greenPen,250,250,100,100
	invoke GdipDrawRectangleI,graphics,blackPen,250,250,100,100
;   -  
        movd xmm1,wi3
	mov r9d,offset hPen
	invoke GdipCreatePen1,ColorsYellow,,UnitWorld
	invoke GdipSetPenStartCap,hPen,LineCapRoundAnchor
	invoke GdipSetPenEndCap,hPen,LineCapArrowAnchor
	invoke GdipDrawLineI,graphics,hPen,12,92,60,80
;  -  
	mov edx,offset path
	invoke GdipCreatePath,0
	invoke GdipStartPathFigure,path
	invoke GdipAddPathLineI,path,10,200,100,200
	invoke GdipAddPathLineI,path,100,200,100,300
	invoke GdipAddPathLineI,path,100,300,150,300
	invoke GdipSetPenLineJoin,hPen,LineJoinBevel
	invoke GdipDrawPath,graphics,hPen,path
	invoke GdipDeletePath,path	
; 
        mov edx,offset dash
	invoke GdipSetPenDashArray,hPen,,2
	invoke GdipDrawLineI,graphics,hPen,100,50,200,50
	invoke GdipDrawLineI,graphics,hPen,100,70,300,70
;  ,  ,       
;PS_ENDCAP_ROUND   
;PS_ENDCAP_SQUARE    
;PS_ENDCAP_FLAT  PS_ENDCAP_SQUARE,        
;PS_JOIN_BEVEL  
;PS_JOIN_MITER     ,  
;        SetMiterLimit
;,     ,     
; PS_JOIN_BEVEL
;PS_JOIN_ROUND  
;RoundedPath------------------------------
        mov lb.lbStyle,BS_SOLID
        mov lb.lbColor,00000FFh
        mov lb.lbHatch,0
        invoke ExtCreatePen,PS_SOLID or PS_GEOMETRIC or PS_ENDCAP_ROUND or PS_JOIN_ROUND,10,ADDR lb,0,0
        mov hPen,rax
        invoke SelectObject,hdcMem,hPen
        mov oldPen,rax
        ;-------------------
        ; Build the GDI Path
        ;-------------------
        invoke MoveToEx,hdcMem,10,425,0
        invoke LineTo,hdcMem,20,475
        invoke LineTo,hdcMem,30,425
        ;----------------------
        ; Render the built Path
        ;----------------------
        invoke StrokePath,hdcMem
        invoke DeleteObject,hPen
        ;---------------------------------
        ; Draw black lines inside the Path
        ;---------------------------------
        invoke GetStockObject,BLACK_PEN
        invoke SelectObject,hdcMem,eax 
        invoke MoveToEx,hdcMem,10,425,0
        invoke LineTo,hdcMem,20,475
        invoke LineTo,hdcMem,30,425
        ;--------------------------
        ; Describe the type of Path
        ;--------------------------
        invoke SelectObject,hdcMem,oldPen 
;MiteredPath-------------------------------------------
        mov lb.lbStyle,BS_SOLID
        mov lb.lbColor,000FF00h
        mov lb.lbHatch,0
        invoke ExtCreatePen,PS_SOLID or PS_GEOMETRIC or PS_ENDCAP_FLAT or PS_JOIN_MITER,10,ADDR lb,0,0
        mov hPen,rax
        invoke SelectObject,hdcMem,hPen
        mov oldPen,rax
        ;-------------------
        ; Build the GDI Path
        ;-------------------
        invoke MoveToEx,hdcMem,40,425,0
        invoke LineTo,hdcMem,50,475
        invoke LineTo,hdcMem,60,425
        ;----------------------
        ; Render the built path
        ;----------------------
        invoke StrokePath,hdcMem
        invoke DeleteObject,hPen
        ;---------------------------------
        ; Draw black lines inside the Path
        ;---------------------------------
        invoke GetStockObject,BLACK_PEN
        invoke SelectObject,hdcMem,eax 
        invoke MoveToEx,hdcMem,40,425,0
        invoke LineTo,hdcMem,50,475
        invoke LineTo,hdcMem,60,425
        ;--------------------------
        ; Describe the type of Path
        ;--------------------------
        invoke SelectObject,hdcMem,oldPen 
;BeveledPath---------------------------------------------
        mov lb.lbStyle,BS_SOLID
        mov lb.lbColor,0FF0000h
        mov lb.lbHatch,0
        invoke ExtCreatePen,PS_SOLID or PS_GEOMETRIC or PS_ENDCAP_SQUARE or PS_JOIN_BEVEL,10,ADDR lb,0,0
        mov hPen,rax
        invoke SelectObject,hdcMem,hPen
        mov oldPen,rax
        ;-------------------
        ; Build the GDI Path
        ;-------------------
        invoke MoveToEx,hdcMem,70,425,0
        invoke LineTo,hdcMem,80,475
        invoke LineTo,hdcMem,90,425
        ;----------------------
        ; Render the built Path
        ;----------------------
        invoke StrokePath,hdcMem
        invoke DeleteObject,hPen
        ;---------------------------------
        ; Draw black lines inside the Path
        ;---------------------------------
        invoke GetStockObject,BLACK_PEN
        invoke SelectObject,hdcMem,eax 
        invoke MoveToEx,hdcMem,70,425,0
        invoke LineTo,hdcMem,80,475
        invoke LineTo,hdcMem,90,425
        ;--------------------------
        ; Describe the type of Path
        ;--------------------------
        invoke SelectObject,hdcMem,oldPen 
;---------------------------------------------	
	
	jmp wmSIZE
wmEllipses:
;invoke  GdipAddPathEllipse
wmCircle:
; 
	mov r9d,offset hPen
	xor r8d,r8d
	movd xmm1,EpaisseurStylo;    float
	invoke GdipCreatePen1,ColorsGreen;  
;  - 
	mov edx,offset path
	invoke GdipCreatePath,0
	invoke GdipAddPathEllipseI,path,-450,-450,1000,1000
	mov edx,offset hBrush
	invoke GdipCreatePathGradientFromPath,path
	invoke GdipSetPathGradientCenterColor,hBrush,900000ffh
	invoke GdipFillRectangleI,graphics,hBrush,0,0,900,900
	invoke GdipDeletePath,path
	invoke GdipDeleteBrush,hBrush	
; 
	mov edx,offset hBrush
	invoke GdipCreateSolidFill,09000FFFFh;
	mov edx,offset hBrush1
	invoke GdipCreateSolidFill,090FFFF00h;
	mov edx,offset hBrush2
	invoke GdipCreateSolidFill,090FF00FFh;
;  
	invoke GdipFillEllipseI,graphics,hBrush,100,188,200,200
	invoke GdipFillEllipseI,graphics,hBrush1,223,188,200,200
	invoke GdipFillEllipseI,graphics,hBrush2,158,109,200,200
	invoke GdipDrawEllipseI,graphics,hPen,250,270,200,200
;GdipDrawEllipseI(GpGraphics* graphics,GpPen* pen,INT x,INT y,INT width,INT height)
        invoke GdipDeleteBrush,hBrush
        invoke GdipDeleteBrush,hBrush1
        invoke GdipDeleteBrush,hBrush2
	invoke GdipDeletePen,hPen
	jmp wmSIZE
wmText: invoke GdipCreateSolidFill,ColorsBlue,&hBrush
	invoke GdipCreateSolidFill,ColorsYellow,&hBrushX
	invoke GdipCreateLineBrushFromRect,&rectB,ColorsRed,ColorsBlue,1,0,&hBrushG
        invoke GdipCreateStringFormat, NULL, NULL,&hStringFormat
	invoke GdipSetStringFormatAlign, hStringFormat, StringAlignmentCenter
	invoke GdipSetStringFormatLineAlign, hStringFormat, StringAlignmentCenter
 	invoke GdipCreateFontFamilyFromName,&szFontName, 0,&hFontFamily
	movd xmm1,emSize
	invoke GdipCreateFont,hFontFamily,,FontStyleBold,2,&hFont
 	invoke GdipCreateFontFamilyFromName,&szFontNameA,0,&hFontFamilyA
	movd xmm1,emSizeA
 	invoke GdipCreateFont,hFontFamilyA,,FontStyleBold,2,&hFontA
	invoke GdipDrawString,graphics,&szString,21,hFont,&rect,hStringFormat,hBrush
	invoke GdipDrawString,graphics,&szStringA,(SIZEOF szStringA)/2,hFontA,&rectA, hStringFormat, hBrush
	invoke GdipDrawString,graphics,&szStringB,16,hFont,&rectB,hStringFormat, hBrushG
	
	invoke GdipDeleteFontFamily, hFontFamily
	invoke GdipDeleteFontFamily, hFontFamilyA

	invoke GdipDeleteFont,hFont
	invoke GdipDeleteFont,hFontA
	invoke GdipDeleteStringFormat,hStringFormat
	jmp wmSIZE
wmArc:
;invoke  GdipAddPathArc
;arc1, arc2, arc3, arc4, arc5, arcTimer
;  MakeBrush	brushes(0), RgbCol(200, 255, 0, 0)    C8 FF 00 00 ;680000FFC8
;invoke GdiCreateSolidFill,0C8FF0000h,&brushes(0)
;  MakeBrush	brushes(1), RgbCol(100, 0, 255, 0)    64 00 FF 00 ;6800FF0064
;  MakeBrush	brushes(2), RgbCol(100, 0, 0, 255)    64 00 00 FF ;68FF000064
;  MakeBrush	brushes(3), RgbCol(100, 255,255, 0)   64 FF FF 00 ;6800FFFF64
;  MakeBrush	brushes(4), RgbCol(100, 0, 255,255)   64 00 FF FF ;68FFFF0064
;  MakeBrush	brushes(5), RgbCol(200, 0, 255, 0)    C8 00 FF 00 ;6800FF00C8
;For_ ecx=0 To 4
;	GuiFill ecx+arc1, brushes(ecx), 17.0, 40.0; no pen, brushes only
;Next
;For_ ecx=0 To 2
;  imul eax, ecx, 1200		; 1200 = 120 degrees
;  MakePath ecx+arc1, Arc(280:220, eax:1200)	; ellipse w:h, startangle:sweepangle
;Next  280=118h 220=DC 1200=4B0
	jmp wmSIZE
wmBezier:
;invoke GdipAddPathBeziers
	jmp wmSIZE
wmPie:
;invoke GdipAddPathPie
	jmp wmSIZE
wmPolygon:;Polygon(0:123, 86:94, 58:28, 103:83, 152:4, 142:95, 242:111, 145:133, 161:209, 111:148, 71:206, 86:127)
	jmp wmSIZE
wmPolyline:;PolyLine(0:0, 200:0, 200:200, 20:200, 20:20, 180:20, 180:180, 40:180, 40:40, 160:40, 160:160, 60:160, 60:60, 140:60, 140:140, 80:140)
	jmp wmSIZE
wmTriangle:;Polygon(0:200, 100:0, 200:200)
	jmp wmSIZE
wmClosed_curve:;ClosedCurve(314:546, 356:323, 309:267, 202:263, 217:170, 299:122, 467:122, 574:163, 605:256, 498:277, 503:544, 420:570)
	jmp wmSIZE
wmClearScreen:invoke MoveToEx,hdcMem,0,0,0
        invoke PatBlt,hdcMem,0,0,maxX,maxY,PATCOPY
	jmp wmSIZE
wmHelp:	mov ecx,offset mb
	invoke MessageBoxIndirect
ShowHide:invoke EnableMenuItem,hMenu,ID_SHOW,flag_show_hide;MF_GRAYED;1
	xor flag_show_hide,1
	invoke EnableMenuItem,hMenu,ID_HIDE,flag_show_hide;MF_ENABLED;0
        mov edx,SW_RESTORE;9
	cmp flag_show_hide,1
	jne @f
	mov edx,SW_HIDE;0	
@@:	invoke ShowWindow,tbwnd
	jmp wmBYE

wmPAINT:lea edx,ps      		
	invoke BeginPaint
	invoke BitBlt,eax,0,0,maxX,maxY,hdcMem,0,0,SRCCOPY
        lea edx,ps
	invoke EndPaint,hWnd
	jmp wmBYE
wmNOTIFY: ;r9=[lParam]   ;if( LPNMHDR(lParam)->code ==TTN_NEEDTEXT)
	cmp dword ptr [r9+NMHDR._code],TTN_NEEDTEXT
	jnz wmBYE
	mov lpttt,r9	  ;LPTOOLTIPTEXT lpttt = (LPTOOLTIPTEXT) lParam;
	mov eax,dword ptr [r9+NMHDR.idFrom];switch (lpttt->hdr.idFrom) {
	cmp eax,Num_buttons-1	      ;case ID_1:strcpy(lpttt->szText,"Fill blue");break;
	ja wmBYE ;case ID_2:strcpy(lpttt->szText,"Fill green");break;
		;case ID_3:strcpy(lpttt->szText,"Exit");
	lea ecx,[r9+TOOLTIPTEXT.szText]
	invoke lstrcpy,,[pt+rax*8]
	jmp wmBYE
wmCOMMAND:and r8d,11111y;wParam
	jmp [handler+r8*8]
wmSIZE:invoke InvalidateRect,hWnd,0,TRUE;    - 
wmBYE:leave
      retn
handler dq    wmLines,wmRectangles,wmEllipses,wmClearScreen,wmText,wmHelp,\
wmDESTROY,ShowHide,wmArc,wmBezier,wmPie,wmPolygon,wmPolyline,wmTriangle,\
wmClosed_curve,wmCircle
WndProc endp
;---------------------------------------
ClassName	db 'Uncle Remus tales:#5h GDI Plus',0
FileName 	db "br_Rabbit3.cur",0
hGDIplus 	QWORD ?
gdiplusToken	dq ?
gdiplusStartupInput GdiplusStartupInput <1,NULL,FALSE,FALSE>
p1 		POINT <0,300>
p2 		POINT <300,0>
points dd 0,0, 100,0, 100,100, 0,100
graphics 	dq ?
hBrush		dq ?
hBrush1		dq ?
hBrush2		dq ?
maxX 		dq ?
maxY 		dq ?
hbmpDef		dq ?
hdcMem		HDC ?
hbmp 		HBITMAP ?
tbb		TBBUTTON Num_buttons dup(<0>)
szText1		db '',0
szText2		db '',0
szText3         db '',0
szText4		db ' ',0
szText5		db '',0
szText6		db '',0
szText7		db '  ',0
pt		dq szText1,szText2,szText3,szText4,szText5,szText6,szText7
aMybp1		db "btns.bmp",0
MBText db "F1: ",10,"F2: ",10,"F3: ",10,"F4: ",10,"F5:  "
db 10,"F6:   ",10,"F7:   ",10
db "Alt+F4  Ctrl+X:   ",0
mb	label   MSGBOXPARAMS
  dd sizeof MSGBOXPARAMS,?;cbSize	     
  dq 0  ;hwndOwner
  dq IMAGE_BASE  ;hInstance	     
  dq MBText  ;lpszText	   
  dq ClassName  ;lpszCaption
  dd MB_OK or MB_USERICON or MB_TOPMOST,?;dwStyle
  dq IDC_ICON1  ;lpszIcon
  dd 0,?;dwContextHelpId
  dq 0  ;lpfnMsgBoxCallback
  dd 0,?;dwLanguageId
flag_show_hide	dq 0
ACC		dq ?
tbwnd		HWND ?
hMenu		HWND ?
path		dq ?	
EpaisseurStylo	REAL4 3.0
nativePen	dq ?
dash		REAL4 1.0,0.5
hPen		dq ?
blackPen 	dq ?
greenPen 	dq ?
wi1		real4 1.0
wi2 		real4 10.0
wi3		real4 8.0
szHelloWorld DB "Hello GDI+ World!", 0
rect 		RectF <0.0, 80.0, 500.0, 50.0>
rectA 		RectF <0.0,130.0, 500.0, 50.0>
rectB 		RectF <0.0,180.0, 500.0, 50.0>
; unicode strings
szFontNameA:	du <Batang>
szFontName:	du <Century Gothic>
szString:	du <,  GDI+>
szStringA	dw 8108h,8077h,81DDh,819Eh,826Ah," ","G","D","I","+"," ",819Eh,826Ah,"!",0
szStringB:	du <Hello GDI+ World>

emSize		REAL4 30.0
emSizeA		REAL4 30.0

hFontFamily	dq ?
hFontFamilyA	dq ?
hStringFormat	dq ?

oldPen        dq 0
hOldpen dq ?
hRedpen dq ?
hGreenpen dq ?
hBluepen dq ?
hYellowpen dq ?
end
